;;; trsim_ditch_rules---------------------------------------------

;;; utilities-----------------------------------------------------

define :method trsim_kill_agent( a:trsim_agent, b:trsim_agent );
lvars a, b;

    "dead" -> b.trsim_status;
    [] -> b.sim_rulesets;
    draw_move_agent(b);

enddefine;

;;; rules---------------------------------------------------------

define :ruleset trsim_ditch_rules;

vars Status;
rule ditch_kill_bug
    [new_sense_data time = name ?Obj_name type bug status ?Status
        distance = x ?X y ?Y == held false ==]
    [WHERE
        (Status /= "dead") and inside_poly(sim_myself.bar_current_poly, X, Y) ]
==>
    ;;; oh dear, bug is in ditch.
    [LVARS obj]
    [POP11 valof(Obj_name) -> obj; ]
    [do trsim_kill_agent ?obj]

rule ditch_rules_last
     ==>
    [POP11 sim_myself.trsim_clock + 1 -> sim_myself.trsim_clock;]
    [STOP]
enddefine;
